import {InteractiveSpeakingExercise} from "@/interfaces/exam";
import {CommonProps} from ".";
import {useEffect, useState} from "react";
import {BsCheckCircleFill, BsMicFill, BsPauseCircle, BsPlayCircle, BsTrashFill} from "react-icons/bs";
import dynamic from "next/dynamic";
import Button from "../Low/Button";
import useExamStore from "@/stores/examStore";

const Waveform = dynamic(() => import("../Waveform"), {ssr: false});
const ReactMediaRecorder = dynamic(() => import("react-media-recorder").then((mod) => mod.ReactMediaRecorder), {
	ssr: false,
});

export default function InteractiveSpeaking({
	id,
	title,
	text,
	type,
	prompts,
	updateIndex,
	onNext,
	onBack,
}: InteractiveSpeakingExercise & CommonProps) {
	const [recordingDuration, setRecordingDuration] = useState(0);
	const [isRecording, setIsRecording] = useState(false);
	const [mediaBlob, setMediaBlob] = useState<string>();
	const [promptIndex, setPromptIndex] = useState(0);
	const [answers, setAnswers] = useState<{prompt: string; blob: string}[]>([]);

	const hasExamEnded = useExamStore((state) => state.hasExamEnded);

	useEffect(() => {
		if (updateIndex) updateIndex(promptIndex);
	}, [promptIndex, updateIndex]);

	useEffect(() => {
		if (hasExamEnded) {
			onNext({
				exercise: id,
				solutions: mediaBlob ? [{id, solution: mediaBlob}] : [],
				score: {correct: 1, total: 1, missing: 0},
				type,
			});
		}
		// eslint-disable-next-line react-hooks/exhaustive-deps
	}, [hasExamEnded]);

	useEffect(() => {
		let recordingInterval: NodeJS.Timer | undefined = undefined;
		if (isRecording) {
			recordingInterval = setInterval(() => setRecordingDuration((prev) => prev + 1), 1000);
		} else if (recordingInterval) {
			clearInterval(recordingInterval);
		}

		return () => {
			if (recordingInterval) clearInterval(recordingInterval);
		};
	}, [isRecording]);

	useEffect(() => {
		if (promptIndex === answers.length - 1) {
			setMediaBlob(answers[promptIndex].blob);
		}
	}, [answers, promptIndex]);

	const saveAnswer = () => {
		const answer = {
			prompt: prompts[promptIndex].text,
			blob: mediaBlob!,
		};

		setAnswers((prev) => [...prev, answer]);
		setMediaBlob(undefined);
	};

	return (
		<div className="flex flex-col h-full w-full gap-9">
			<div className="flex flex-col w-full gap-8 bg-mti-gray-smoke rounded-xl py-8 pb-12 px-16">
				<div className="flex flex-col gap-3">
					<span className="font-semibold">{title}</span>
				</div>
				{prompts && prompts.length > 0 && (
					<div className="flex flex-col gap-4 w-full items-center">
						<video key={promptIndex} autoPlay controls className="max-w-3xl rounded-xl">
							<source src={prompts[promptIndex].video_url} />
						</video>
					</div>
				)}
			</div>

			<ReactMediaRecorder
				audio
				key={promptIndex}
				onStop={(blob) => setMediaBlob(blob)}
				render={({status, startRecording, stopRecording, pauseRecording, resumeRecording, clearBlobUrl, mediaBlobUrl}) => (
					<div className="w-full p-4 px-8 bg-transparent border-2 border-mti-gray-platinum rounded-2xl flex-col gap-8 items-center">
						<p className="text-base font-normal">Record your answer:</p>
						<div className="flex gap-8 items-center justify-center py-8">
							{status === "idle" && (
								<>
									<div className="w-full h-2 max-w-4xl bg-mti-gray-smoke rounded-full" />
									{status === "idle" && (
										<BsMicFill
											onClick={() => {
												setRecordingDuration(0);
												startRecording();
												setIsRecording(true);
											}}
											className="h-5 w-5 text-mti-gray-cool cursor-pointer"
										/>
									)}
								</>
							)}
							{status === "recording" && (
								<>
									<div className="flex gap-4 items-center">
										<span className="text-xs w-9">
											{Math.floor(recordingDuration / 60)
												.toString(10)
												.padStart(2, "0")}
											:
											{Math.floor(recordingDuration % 60)
												.toString(10)
												.padStart(2, "0")}
										</span>
									</div>
									<div className="w-full h-2 max-w-4xl bg-mti-gray-smoke rounded-full" />
									<div className="flex gap-4 items-center">
										<BsPauseCircle
											onClick={() => {
												setIsRecording(false);
												pauseRecording();
											}}
											className="text-red-500 w-8 h-8 cursor-pointer"
										/>
										<BsCheckCircleFill
											onClick={() => {
												setIsRecording(false);
												stopRecording();
											}}
											className="text-mti-purple-light w-8 h-8 cursor-pointer"
										/>
									</div>
								</>
							)}
							{status === "paused" && (
								<>
									<div className="flex gap-4 items-center">
										<span className="text-xs w-9">
											{Math.floor(recordingDuration / 60)
												.toString(10)
												.padStart(2, "0")}
											:
											{Math.floor(recordingDuration % 60)
												.toString(10)
												.padStart(2, "0")}
										</span>
									</div>
									<div className="w-full h-2 max-w-4xl bg-mti-gray-smoke rounded-full" />
									<div className="flex gap-4 items-center">
										<BsPlayCircle
											onClick={() => {
												setIsRecording(true);
												resumeRecording();
											}}
											className="text-mti-purple-light w-8 h-8 cursor-pointer"
										/>
										<BsCheckCircleFill
											onClick={() => {
												setIsRecording(false);
												stopRecording();
											}}
											className="text-mti-purple-light w-8 h-8 cursor-pointer"
										/>
									</div>
								</>
							)}
							{status === "stopped" && mediaBlobUrl && (
								<>
									<Waveform audio={mediaBlobUrl} waveColor="#FCDDEC" progressColor="#EF5DA8" />
									<div className="flex gap-4 items-center">
										<BsTrashFill
											className="text-mti-gray-cool cursor-pointer w-5 h-5"
											onClick={() => {
												setRecordingDuration(0);
												clearBlobUrl();
												setMediaBlob(undefined);
											}}
										/>

										<BsMicFill
											onClick={() => {
												clearBlobUrl();
												setRecordingDuration(0);
												startRecording();
												setIsRecording(true);
												setMediaBlob(undefined);
											}}
											className="h-5 w-5 text-mti-gray-cool cursor-pointer"
										/>
									</div>
								</>
							)}
						</div>
					</div>
				)}
			/>

			<div className="self-end flex justify-between w-full  gap-8">
				<Button
					color="purple"
					variant="outline"
					onClick={() =>
						onBack({
							exercise: id,
							solutions: answers,
							score: {correct: 1, total: 1, missing: 0},
							type,
						})
					}
					className="max-w-[200px] self-end w-full">
					Back
				</Button>
				<Button
					color="purple"
					disabled={!mediaBlob}
					onClick={() => {
						saveAnswer();
						if (promptIndex + 1 < prompts.length) {
							setPromptIndex((prev) => prev + 1);
							return;
						}
						onNext({
							exercise: id,
							solutions: [
								...answers,
								{
									prompt: prompts[promptIndex].text,
									blob: mediaBlob!,
								},
							],
							score: {correct: 1, total: 1, missing: 0},
							type,
						});
					}}
					className="max-w-[200px] self-end w-full">
					{promptIndex + 1 < prompts.length ? "Next Prompt" : "Submit"}
				</Button>
			</div>
		</div>
	);
}
